<html>
  <head>
    <title>Objects 3</title>
    <script>
      function execute() {
        const persons = [
          { firstname: 'Natalya', lastname: 'Osipenko', age: 61 },
          { firstname: 'Kristina', lastname: 'Osipenko', age:23 },
          { firstname: 'Artem', lastname: 'Korhov', age: 25 },
          { firstname: 'Artem', lastname: 'Seredinskiy', age: 20 },
          { firstname: 'Artem', lastname: 'Artsiomenka', age: 20 },
          { firstname: 'Sergey', lastname: 'Osipenko', age: 20 },
          { firstname: 'Vinni', lastname: 'Puh', age: 15 }
        ];

        const groupPeople = (arr, group) => {
          let temp = {};
          arr.forEach((x, i) => {
            if (x[group] in temp) {
              temp[x[group]] = [...temp[x[group]], x];
            } else {
              temp[x[group]] = [x];
            }
          });
          return temp;
        };
        
        const output = Object.keys(groupPeople(persons, property.value)).map(x => `<li>${x}</li>`).join('');
        result.innerHTML = output;
      }
    </script>
  </head>
  <body>
    <p>Group: <input id="property" /> // lastname, firstname, age</p>
    <button onclick="execute()">Execute</button>
    <ul id="result"></ul>
  </body>
</html>
